import { Injectable, EventEmitter, Component, Input, Output, HostListener, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import * as moment$2 from 'moment';
import { localeData, weekdays, monthsShort } from 'moment';
import { FormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const moment = moment$2;
class Angular2MomentPickerService {
    constructor() {
        this.moment = moment()
            .set('minute', 0)
            .set('seconds', 0);
        this.yearsFormat = 'YYYY';
        this.monthsFormat = 'MMM';
        this.daysFormat = 'D';
        this.hoursFormat = 'HH:[00]';
        this.hoursStart = 0;
        this.minutesStep = 5;
        this.minutesStart = 0;
        this.minutesEnd = 59;
        this.secondsFormat = 'ss';
        this.secondsStep = 1;
        this.secondsStart = 0;
        this.secondsEnd = 59;
    }
}
Angular2MomentPickerService.decorators = [
    { type: Injectable }
];
if (false) {
    /** @type {?} */
    Angular2MomentPickerService.prototype.moment;
    /** @type {?} */
    Angular2MomentPickerService.prototype.locale;
    /** @type {?} */
    Angular2MomentPickerService.prototype.format;
    /** @type {?} */
    Angular2MomentPickerService.prototype.yearsFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.monthsFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.daysFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.hoursFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.hoursStart;
    /** @type {?} */
    Angular2MomentPickerService.prototype.minutesFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.minutesStep;
    /** @type {?} */
    Angular2MomentPickerService.prototype.minutesStart;
    /** @type {?} */
    Angular2MomentPickerService.prototype.minutesEnd;
    /** @type {?} */
    Angular2MomentPickerService.prototype.secondsFormat;
    /** @type {?} */
    Angular2MomentPickerService.prototype.secondsStep;
    /** @type {?} */
    Angular2MomentPickerService.prototype.secondsStart;
    /** @type {?} */
    Angular2MomentPickerService.prototype.secondsEnd;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {number} */
const ViewState = {
    Decade: 0,
    Year: 1,
    Month: 2,
    Date: 3,
    Hour: 4,
    Minute: 5,
};
ViewState[ViewState.Decade] = 'Decade';
ViewState[ViewState.Year] = 'Year';
ViewState[ViewState.Month] = 'Month';
ViewState[ViewState.Date] = 'Date';
ViewState[ViewState.Hour] = 'Hour';
ViewState[ViewState.Minute] = 'Minute';
/** @type {?} */
const moment$1 = moment$2;
class Angular2MomentPickerComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        this.globals = globals;
        this.locale = 'en-us';
        this.onlyupdateatend = false;
        this.changed = new EventEmitter();
        this.viewStates = ViewState;
        this.currentView = ViewState.Decade;
        this.open = false;
        this.isFocusInsideComponent = false;
        this.isComponentClicked = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.moment) {
            this.moment = moment$1();
        }
        this.globals.locale = this.locale;
        if (this.moment) {
            this.globals.moment = this.moment;
        }
        this.viewStack = this.buildViewStack();
    }
    /**
     * @return {?}
     */
    click() {
        this.isFocusInsideComponent = true;
        this.isComponentClicked = true;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onOutsideClick(event) {
        if (!this.isFocusInsideComponent && this.isComponentClicked) {
            this.hide();
            this.isComponentClicked = false;
        }
        this.isFocusInsideComponent = false;
    }
    /**
     * @return {?}
     */
    toggle() {
        this.isFocusInsideComponent = true;
        this.isComponentClicked = true;
        if (this.startview) {
            this.setCurrentView(this.viewStateFromString(this.startview));
        }
        else if (this.minview) {
            this.setCurrentView(this.viewStateFromString(this.minview));
        }
        else {
            this.setCurrentView(ViewState.Decade);
        }
        this.open = !this.open;
    }
    /**
     * @return {?}
     */
    next() {
        /** @type {?} */
        const currentViewIndex = this.viewStack.indexOf(this.currentView);
        if (currentViewIndex === this.viewStack.length) {
            this.hide();
        }
        else {
            this.setCurrentView(this.viewStack[currentViewIndex + 1]);
        }
    }
    /**
     * @return {?}
     */
    previous() {
        /** @type {?} */
        const currentViewIndex = this.viewStack.indexOf(this.currentView);
        if (currentViewIndex === 0) {
            return;
        }
        else {
            this.setCurrentView(this.viewStack[currentViewIndex - 1]);
        }
    }
    /**
     * @private
     * @return {?}
     */
    buildViewStack() {
        /** @type {?} */
        const stack = [];
        /** @type {?} */
        const min = this.minview ? this.viewStateFromString(this.minview) : ViewState.Decade;
        /** @type {?} */
        const max = this.maxview ? this.viewStateFromString(this.maxview) : ViewState.Minute;
        for (let i = min; i <= max; i++) {
            stack.push(i);
        }
        return stack;
    }
    /**
     * @private
     * @return {?}
     */
    hide() {
        this.open = false;
    }
    /**
     * @private
     * @param {?} view
     * @return {?}
     */
    setCurrentView(view) {
        this.currentView = view;
        this.viewChanged();
    }
    /**
     * @private
     * @param {?} view
     * @return {?}
     */
    viewStateFromString(view) {
        switch (view) {
            case 'decade':
                return ViewState.Decade;
            case 'year':
                return ViewState.Year;
            case 'month':
                return ViewState.Month;
            case 'date':
                return ViewState.Date;
            case 'hour':
                return ViewState.Hour;
            case 'minute':
                return ViewState.Minute;
            default:
                return ViewState.Decade;
        }
    }
    /**
     * @private
     * @return {?}
     */
    viewChanged() {
        this.moment = this.globals.moment.clone();
        if (!this.onlyupdateatend) {
            this.changed.emit(this.moment);
        }
        else if (this.onlyupdateatend && !this.currentView) {
            this.changed.emit(this.moment);
        }
    }
}
Angular2MomentPickerComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line: component-selector
                selector: 'angular2-moment-picker',
                template: "<div *ngIf=\"open\">\n  <lib-decade-component\n    *ngIf=\"currentView === viewStates.Decade\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  ></lib-decade-component>\n  <lib-year-component\n    *ngIf=\"currentView === viewStates.Year\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-year-component>\n  <lib-month-component\n    *ngIf=\"currentView === viewStates.Month\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-month-component>\n  <lib-date-component\n    *ngIf=\"currentView === viewStates.Date\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-date-component>\n  <lib-hour-component\n    *ngIf=\"currentView === viewStates.Hour\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  >\n  </lib-hour-component>\n  <lib-minute-component\n    *ngIf=\"currentView === viewStates.Minute\"\n    (selectEmitter)=\"next()\"\n    (titleEmitter)=\"previous()\"\n  ></lib-minute-component>\n</div>\n",
                providers: [Angular2MomentPickerService]
            }] }
];
/** @nocollapse */
Angular2MomentPickerComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
Angular2MomentPickerComponent.propDecorators = {
    locale: [{ type: Input }],
    minview: [{ type: Input }],
    maxview: [{ type: Input }],
    maxdate: [{ type: Input }],
    startview: [{ type: Input }],
    onlyupdateatend: [{ type: Input }],
    moment: [{ type: Input }],
    changed: [{ type: Output }],
    click: [{ type: HostListener, args: ['click',] }],
    onOutsideClick: [{ type: HostListener, args: ['document:click', ['$event'],] }]
};
if (false) {
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.locale;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.minview;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.maxview;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.maxdate;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.startview;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.onlyupdateatend;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.moment;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.changed;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.viewStates;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.currentView;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.viewStack;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.open;
    /**
     * @type {?}
     * @private
     */
    Angular2MomentPickerComponent.prototype.isFocusInsideComponent;
    /**
     * @type {?}
     * @private
     */
    Angular2MomentPickerComponent.prototype.isComponentClicked;
    /** @type {?} */
    Angular2MomentPickerComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        this.globals = globals;
        this.perLine = 4;
        this.rows = [];
        this.selectEmitter = new EventEmitter();
        this.titleEmitter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    leftArrow() {
        this.globals.moment.subtract(1, this.type);
        this.reset();
    }
    /**
     * @return {?}
     */
    rightArrow() {
        this.globals.moment.add(1, this.type);
        this.reset();
    }
    /**
     * @return {?}
     */
    reset() {
        this.rows = [];
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        return;
    }
    /**
     * @return {?}
     */
    title() {
        return '';
    }
    /**
     * @return {?}
     */
    titleSelected() {
        this.titleEmitter.emit();
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        return;
    }
}
BaseComponent.decorators = [
    { type: Component, args: [{
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n"
            }] }
];
/** @nocollapse */
BaseComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
BaseComponent.propDecorators = {
    selectEmitter: [{ type: Output }],
    titleEmitter: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    BaseComponent.prototype.perLine;
    /** @type {?} */
    BaseComponent.prototype.type;
    /** @type {?} */
    BaseComponent.prototype.rows;
    /** @type {?} */
    BaseComponent.prototype.localMoment;
    /** @type {?} */
    BaseComponent.prototype.selectEmitter;
    /** @type {?} */
    BaseComponent.prototype.titleEmitter;
    /** @type {?} */
    BaseComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class HourComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
        this.type = 'hour';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        let i = 0;
        /** @type {?} */
        const minute = this.globals.moment.clone().startOf('hour').minute(0);
        /** @type {?} */
        const minutesFormat = this.globals.minutesFormat ||
            localeData(this.globals.locale).longDateFormat('LT').replace(/[aA]/, '').trim();
        for (let m = 0; m < 60; m += this.globals.minutesStep) {
            /** @type {?} */
            const index = Math.floor(i / this.perLine);
            /** @type {?} */
            const isSelectable = true;
            if (!this.rows[index]) {
                this.rows[index] = [];
            }
            this.rows[index].push({
                year: minute.year(),
                month: minute.month(),
                date: minute.date(),
                hourr: minute.hour(),
                minute: minute.minute(),
                label: minute.format(minutesFormat),
                selectable: isSelectable,
                class: [
                    minute.isSame(this.globals.moment, 'minute') ? 'selected' : '',
                ]
            });
            i++;
            minute.add(this.globals.minutesStep, 'minutes');
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('minute', item.minute);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        return this.globals.moment.clone().startOf('hour').format('lll');
    }
}
HourComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-hour-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
HourComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
if (false) {
    /** @type {?} */
    HourComponent.prototype.type;
    /** @type {?} */
    HourComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DateComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
        this.type = 'day';
        this.selectEmitter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        const hour = this.globals.moment.clone().startOf('day').hour(this.globals.hoursStart);
        for (let h = 0; h <= 23; h++) {
            /** @type {?} */
            const index = Math.floor(h / this.perLine);
            /** @type {?} */
            const isSelectable = true;
            if (!this.rows[index]) {
                this.rows[index] = [];
            }
            this.rows[index].push({
                year: hour.year(),
                month: hour.month(),
                date: hour.date(),
                hour: hour.hour(),
                minute: hour.minute(),
                label: hour.format(this.globals.hoursFormat),
                selectable: isSelectable,
                class: [
                    hour.isSame(this.globals.moment, 'hour') ? 'selected' : '',
                ]
            });
            hour.add(1, 'hours');
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('hour', item.hour).startOf('minute').set('minutes', 0).set('seconds', 0);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        return this.globals.moment.format('LL');
    }
}
DateComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-date-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
DateComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
DateComponent.propDecorators = {
    selectEmitter: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    DateComponent.prototype.type;
    /** @type {?} */
    DateComponent.prototype.selectEmitter;
    /** @type {?} */
    DateComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MonthComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
        this.perLine = weekdays().length;
        this.type = 'month';
        this.selectEmitter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        const month = this.globals.moment.month();
        /** @type {?} */
        const isSelectable = true;
        /** @type {?} */
        const day = this.globals.moment.clone().startOf('month').startOf('week').hour(12);
        /** @type {?} */
        const firstWeek = day.week();
        /** @type {?} */
        const lastWeek = firstWeek + 5;
        for (let week = firstWeek; week <= lastWeek; week++) {
            this.rows[week] = Array.apply(null, Array(this.perLine)).map((/**
             * @return {?}
             */
            () => {
                /** @type {?} */
                const date = {
                    year: day.year(),
                    month: day.month(),
                    date: day.date(),
                    hour: day.hour(),
                    minute: day.minute(),
                    label: day.format(this.globals.daysFormat),
                    selectable: isSelectable,
                    class: [
                        day.isSame(this.globals.moment, 'day') ? 'selected' : '',
                        !isSelectable || day.month() !== month ? 'disabled' : ''
                    ]
                };
                day.add(1, 'days');
                return date;
            }));
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('date', item.date);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        return this.globals.moment.format('MMMM YYYY');
    }
}
MonthComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-month-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
MonthComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
MonthComponent.propDecorators = {
    selectEmitter: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    MonthComponent.prototype.perLine;
    /** @type {?} */
    MonthComponent.prototype.type;
    /** @type {?} */
    MonthComponent.prototype.selectEmitter;
    /** @type {?} */
    MonthComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class YearComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
        this.type = 'year';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        const month = this.globals.moment.clone().startOf('year').clone();
        /** @type {?} */
        const months = monthsShort();
        /** @type {?} */
        const isSelectable = true;
        months.forEach((/**
         * @param {?} label
         * @param {?} i
         * @return {?}
         */
        (label, i) => {
            /** @type {?} */
            const index = Math.floor(i / this.perLine);
            if (!this.rows[index]) {
                this.rows[index] = [];
            }
            this.rows[index].push({
                year: month.year(),
                month: month.month(),
                date: month.date(),
                hour: month.hour(),
                minute: month.minute(),
                label: month.format(this.globals.monthsFormat),
                selectable: isSelectable,
                class: [
                    month.isSame(this.localMoment, 'month') ? 'selected' : '',
                ]
            });
            month.add(1, 'months');
        }));
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('month', item.month);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        return this.globals.moment.format('YYYY');
    }
}
YearComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-year-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
YearComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
if (false) {
    /** @type {?} */
    YearComponent.prototype.type;
    /** @type {?} */
    YearComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DecadeComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        const year = this.globals.moment.clone();
        /** @type {?} */
        const firstYear = Math.floor(year.year() / 10) * 10 - 1;
        year.year(firstYear);
        for (let y = 0; y < 12; y++) {
            /** @type {?} */
            const index = Math.floor(y / this.perLine);
            /** @type {?} */
            const isSelectable = true;
            if (!this.rows[index]) {
                this.rows[index] = [];
            }
            this.rows[index].push({
                year: year.year(),
                month: year.month(),
                date: year.date(),
                hour: year.hour(),
                minute: year.minute(),
                label: year.format(this.globals.yearsFormat),
                selectable: isSelectable,
                class: [
                    year.isSame(this.globals.moment, 'year') ? 'selected' : '',
                ]
            });
            year.add(1, 'year');
        }
    }
    /**
     * @return {?}
     */
    leftArrow() {
        this.globals.moment.subtract(10, 'years');
        this.reset();
    }
    /**
     * @return {?}
     */
    rightArrow() {
        this.globals.moment.add(10, 'years');
        this.reset();
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('year', item.year);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        /** @type {?} */
        const year = this.globals.moment.clone();
        return [year.format('YYYY'), year.subtract(9, 'years').format('YYYY')].reverse().join(' - ');
    }
}
DecadeComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-decade-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
DecadeComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
if (false) {
    /** @type {?} */
    DecadeComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class MinuteComponent extends BaseComponent {
    /**
     * @param {?} globals
     */
    constructor(globals) {
        super(globals);
        this.globals = globals;
        this.perLine = 6;
        this.type = 'minute';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.render();
    }
    /**
     * @return {?}
     */
    render() {
        /** @type {?} */
        let i = 0;
        /** @type {?} */
        const second = this.globals.moment.clone().startOf('minute').second(this.globals.secondsStart);
        for (let s = 0; s <= this.globals.secondsEnd - this.globals.secondsStart; s += this.globals.secondsStep) {
            /** @type {?} */
            const index = Math.floor(i / this.perLine);
            /** @type {?} */
            const isSelectable = true;
            if (!this.rows[index]) {
                this.rows[index] = [];
            }
            this.rows[index].push({
                year: second.year(),
                month: second.month(),
                date: second.date(),
                hour: second.hour(),
                minute: second.minute(),
                second: second.second(),
                label: second.format(this.globals.secondsFormat),
                selectable: isSelectable,
                class: [
                    second.isSame(this.globals.moment, 'second') ? 'selected' : '',
                ]
            });
            i++;
            second.add(this.globals.secondsStep, 'seconds');
        }
    }
    /**
     * @param {?} item
     * @return {?}
     */
    select(item) {
        this.globals.moment.set('seconds', item.second);
        this.selectEmitter.emit();
    }
    /**
     * @return {?}
     */
    title() {
        return this.globals.moment.clone().startOf('minute').format('lll');
    }
}
MinuteComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-minute-component',
                template: "\n<div class=\"moment-picker\">\n    <div class=\"moment-picker-container\">\n        <table class=\"header-view\">\n            <thead>\n                <tr>\n                    <th class=\"view.previous.selectable\" (click)=\"leftArrow()\">&larr;</th>\n                    <th (click)=\"titleSelected()\">{{ title() }}</th>\n                    <th class=\"view.next.selectable\" (click)=\"rightArrow()\">&rarr;</th>\n                </tr>\n            </thead>\n        </table>\n\n        <div class=\"moment-picker-specific-views\">\n            <table>\n                <!-- ng-if=\"views[view.selected].headers\"-->\n                <!-- <thead>\n                    <tr>\n                        ng-repeat=\"header in views[view.selected].headers\" ng-bind=\"header\"\n                        <th>fdsa</th>\n                    </tr>\n                </thead> -->\n                <tbody>\n\n                    <tr *ngFor=\"let row of rows\">\n                        <td *ngFor=\"let item of row\" [ngClass]=\"item.class\" (click)=\"item.selectable && select(item)\">\n                            {{ item.label }}</td>\n                    </tr>\n                </tbody>\n            </table>\n        </div>\n        <!-- ng-if=\"additions.bottom\"  -->\n        <div class=\"moment-picker-addition bottom\"></div>\n    </div>\n</div>\n",
                styles: [".moment-picker-input{cursor:pointer}.moment-picker{position:absolute;z-index:1060}.moment-picker .moment-picker-container{color:#404040;min-width:15em;background:#fff;padding:4px;border:1px solid #f0f3f4;border-radius:4px;position:absolute;margin-top:4px;margin-left:-.5em;box-shadow:0 2px 4px fade(#000,7.5%)}.moment-picker .moment-picker-container:after,.moment-picker .moment-picker-container:before{content:\"\";display:block;width:0;height:0;border:8px solid transparent;border-top:none;position:absolute;top:-9px;left:15px}.moment-picker .moment-picker-container:before{border-bottom-color:#f0f3f4;border-width:9px}.moment-picker .moment-picker-container:after{border-bottom-color:#fff;margin-top:1px;margin-left:1px}.moment-picker.inline{display:block;position:relative}.moment-picker.inline .moment-picker-container{position:relative;margin:0}.moment-picker.inline .moment-picker-container:after,.moment-picker.inline .moment-picker-container:before{content:none}.moment-picker.top .moment-picker-container{bottom:100%;margin-top:auto;margin-bottom:4px}.moment-picker.top .moment-picker-container:after,.moment-picker.top .moment-picker-container:before{border:8px solid transparent;border-bottom:none;top:auto;bottom:-9px}.moment-picker.top .moment-picker-container:before{border-top-color:#f0f3f4;border-width:9px}.moment-picker.top .moment-picker-container:after{border-top-color:#fff;margin-top:auto;margin-bottom:1px}.moment-picker.right .moment-picker-container{right:0;margin-left:auto;margin-right:-.5em}.moment-picker.right .moment-picker-container:after,.moment-picker.right .moment-picker-container:before{left:auto;right:15px}.moment-picker.right .moment-picker-container:after{margin-left:auto;margin-right:1px}.moment-picker table{border-collapse:collapse;border-spacing:0;min-width:100%;table-layout:fixed}.moment-picker th{font-weight:700}.moment-picker th:first-child,.moment-picker th:last-child{width:2em}.moment-picker td,.moment-picker th{padding:0;text-align:center;min-width:2em;height:2em;text-shadow:0 1px 0 fade(#fff,90%);cursor:pointer;border-radius:4px}.moment-picker td:hover,.moment-picker th:hover{background-color:#fafbfb;background-image:-webkit-gradient(linear,left top,left bottom,from(#f0f3f4),to(#fafbfb));background-image:linear-gradient(#f0f3f4,#fafbfb)}.moment-picker td.disabled,.moment-picker td.disabled:hover,.moment-picker th.disabled,.moment-picker th.disabled:hover{color:#abbbc7;background:0 0;cursor:default}.moment-picker td.today{background:#e4eef5;color:#404040;text-shadow:0 1px 0 fade(#fff,90%)}.moment-picker td.selected{color:#fff;text-shadow:0 -1px 0 fade(#000,30%);border-color:#3ca0dd;background-color:#45b1e8;background-image:-webkit-gradient(linear,left top,left bottom,from(#45b1e8),to(#3097de));background-image:linear-gradient(#45b1e8,#3097de)}.moment-picker td.highlighted{background-image:radial-gradient(transparent,fade(#000,15%))}.moment-picker .decade-view td,.moment-picker .year-view td{height:3.4em}.moment-picker .month-view .moment-picker-specific-views th{background:0 0;cursor:default}.moment-picker .month-view td{width:1.4285714286em}.moment-picker .day-view td,.moment-picker .hour-view td{height:2.3333333333em}.moment-picker .minute-view td{height:1.8em}"]
            }] }
];
/** @nocollapse */
MinuteComponent.ctorParameters = () => [
    { type: Angular2MomentPickerService }
];
if (false) {
    /** @type {?} */
    MinuteComponent.prototype.perLine;
    /** @type {?} */
    MinuteComponent.prototype.type;
    /** @type {?} */
    MinuteComponent.prototype.globals;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Angular2MomentPickerModule {
}
Angular2MomentPickerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    Angular2MomentPickerComponent,
                    BaseComponent,
                    HourComponent,
                    DateComponent,
                    MonthComponent,
                    YearComponent,
                    DecadeComponent,
                    MinuteComponent
                ],
                imports: [CommonModule, FormsModule],
                exports: [Angular2MomentPickerComponent],
                providers: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Angular2MomentPickerComponent, Angular2MomentPickerModule, Angular2MomentPickerService as ɵa, BaseComponent as ɵb, HourComponent as ɵc, DateComponent as ɵd, MonthComponent as ɵe, YearComponent as ɵf, DecadeComponent as ɵg, MinuteComponent as ɵh };
//# sourceMappingURL=angular2-moment-picker.js.map
